/*
** File: info.h  
** Project: ADMXRC3 module driver
** Purpose: Defines function prototypes for informational IOCTL handlers.
**
** (C) Copyright Alpha Data 2009
*/

#if !defined(ADATA_ADMXRC3_INFO_H)
#define ADATA_ADMXRC3_INFO_H

#include <df.h>
#include "device.h"
#include <admxrc3/types.h>

extern void
setupIoctlsGetFpgaInfo(
	Admxrc3DeviceContext* pDevCtx,
  IOCTLS_ADMXRC3_GETFPGAINFO* pIoctl,
  ADMXRC3_FPGA_TYPE device,
  ADMXRC3_PACKAGE_TYPE package,
  const char* pSpeedGrade,
  const char* pStepping,
  boolean_t bPresent);

extern DfIoStatus
ioctlGetBankInfo(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int inSize,
  unsigned int outSize);

extern DfIoStatus
ioctlGetCardInfo(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int outSize);

extern DfIoStatus
ioctlGetCardInfoEx(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int outSize);

extern DfIoStatus
ioctlGetFpgaInfo(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int inSize,
  unsigned int outSize);

extern DfIoStatus
ioctlGetDriverVersion(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int outSize);

extern DfIoStatus
ioctlGetWindowInfo(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int inSize,
  unsigned int outSize);

extern DfIoStatus
ioctlGetCommonBufferCount(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int outSize);

extern DfIoStatus
ioctlGetCommonBufferInfo(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int inSize,
  unsigned int outSize);

extern DfIoStatus
ioctlGetCommonBufferInfoThunk(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int inSize,
  unsigned int outSize);

#endif
